<script>
import { items } from '~/lib/items';
import { mapActions, mapGetters, mapState } from 'vuex';

export default {
  props: {
    itemId: {
      type: String,
      required: true
    }
  },
  methods: {
    ...mapActions(['selectItem', 'setCursorPointer', 'setCursorNormal'])
  },
  computed: {
    ...mapState(['inventoryById']),
    ...mapGetters(['selectionById']),
    item() {
      return this.inventoryById[this.itemId];
    },
    isSelected() {
      return !!this.selectionById[this.itemId];
    },
    baseUrl() {
      return this.$router.options.base;
    },
    imageUrlPart() {
      const { image = '' } = items[this.item.name] || {};

      return image || `assets/${this.item.name}.png`;
    },
    imageUrl() {
      return `${this.baseUrl}${this.imageUrlPart}`;
    }
  }
};
</script>

<template>
  <div
    class="p-1 border border-gray-800 rounded-lg flex items-center justify-center"
    :class="isSelected ? 'bg-purple-500' : 'hover:bg-gray-700'"
    @click="selectItem(itemId)"
    @mouseover="setCursorPointer"
    @mouseleave="setCursorNormal"
  >
    <img :src="imageUrl" class="max-w-full max-h-full" />
  </div>
</template>
